// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

///
/// \file engine.h
/// \brief fennec::engine definition
///
///
/// \details
/// \author Medusa Slockbower
///
/// \copyright Copyright © 2025 Medusa Slockbower ([GPLv3](https://www.gnu.org/licenses/gpl-3.0.en.html))
///
///

///
/// \page page_fennec_documentation Documentation
///
/// \section page_documentation_contents Main Page
/// 1. \ref introduction "Introduction"
/// 2. \ref introduction "Building from Source"
///    1. \ref building-from-source "Building from Source"
///    2. \ref building-from-terminal "Building from Terminal"
///    3. \ref running-the-test-suite "Running the Test Suite"
/// 3. \ref usage "Usage"
/// 4. \ref contribution "Contribution"
///
/// \section Libraries
/// \anchor libraries
/// - \subpage page_fennec_lang
/// - \subpage page_fennec_math
///
/// \copyright Copyright © 2025 Medusa Slockbower ([GPLv3](https://www.gnu.org/licenses/gpl-3.0.en.html))
///

#ifndef FENNEC_CORE_ENGINE_H
#define FENNEC_CORE_ENGINE_H

#endif // FENNEC_CORE_ENGINE_H
