//
// Created by medusa on 5/19/25.
//

#ifndef FENNEC_MEMORY_DETAIL_MEMORY_H
#define FENNEC_MEMORY_DETAIL_MEMORY_H

#include <fennec/lang/types.h>

namespace fennec
{

namespace detail
{

// helper for copying 2 bytes at once
constexpr size_t __memcpy_16(void* dst, const void* src)
	{ *static_cast<uint16_t*>(dst) = *static_cast<const uint16_t*>(src); return 2; }

// helper for copying 4 bytes at once
constexpr size_t __memcpy_32(void* dst, const void* src)
	{ *static_cast<uint32_t*>(dst) = *static_cast<const uint32_t*>(src); return 4; }

// helper for copying 8 bytes at once
constexpr size_t __memcpy_64(void* dst, const void* src)
	{ *static_cast<uint64_t*>(dst) = *static_cast<const uint64_t*>(src); return 8; }

}

}

#endif // FENNEC_MEMORY_DETAIL_MEMORY_H
