// =====================================================================================================================
//  fennec-test, a program to execute unit tests for fennec
//  Copyright © 2025  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <iostream>

#include "tests/test_scalar.h"
#include "tests/test_vector.h"
#include "tests/test_geometric.h"
#include "tests/math/test_matrix.h"

#include <fennec/memory/bits.h>


int main(int, char **)
{
	fennec_test_spacer(1);

	fennec_test_section("fennec-test, a program to execute unit tests for fennec");

	fennec_test_spacer(2);

	fennec_test_section(scalar tests =================================================================================);

	fennec_test_spacer(2);

	fennec::test::fennec_test_scalar();

	fennec_test_spacer(3);

	fennec_test_section(vector tests =================================================================================);

	fennec_test_spacer(2);

	fennec::test::fennec_test_vector();

	fennec_test_spacer(3);

	fennec_test_section(geometric tests ==============================================================================);

	fennec_test_spacer(2);

	fennec::test::fennec_test_geometric();

	fennec_test_spacer(3);

	fennec_test_section(matrix tests =================================================================================);

	fennec_test_spacer(2);

	fennec::test::fennec_test_matrix();

	return 0;
}
